<?php
rex_perm::register('consent_manager[texteditonly]');
if (rex::isBackend() && rex::getUser()) {
    if (!rex::getUser()->isAdmin() && rex::getUser()->hasPerm('consent_manager[texteditonly]')) {
        $page = $this->getProperty('page');
        if ($page) {
            foreach (['cookiegroup', 'cookie', 'domain', 'config', 'setup', 'help'] as $removepage) {
                unset($page['subpages'][$removepage]);
            }
            $this->setProperty('page', $page);
        }
    }
}

rex_extension::register('PACKAGES_INCLUDED', function () {
    if (rex::getUser())
    {
        if (rex::getUser()->isAdmin() && rex::isDebugMode() && rex_request_method() == 'get')
        {
            $compiler = new rex_scss_compiler();
            $compiler->setRootDir($this->getPath());
            $compiler->setScssFile($this->getPath('scss/consent_manager_backend.scss'));
            $compiler->setCssFile($this->getPath('assets/consent_manager_backend.css'));
            $compiler->compile();
            $compiler->setScssFile($this->getPath('scss/consent_manager_frontend.scss'));
            $compiler->setCssFile($this->getPath('assets/consent_manager_frontend.css'));
            $compiler->compile();
            rex_file::copy($this->getPath('assets/consent_manager_frontend.css'), $this->getAssetsPath('consent_manager_frontend.css'));
            rex_file::copy($this->getPath('assets/consent_manager_backend.css'), $this->getAssetsPath('consent_manager_backend.css'));
            rex_file::copy($this->getPath('assets/consent_manager_polyfills.js'), $this->getAssetsPath('consent_manager_frontend.js'));
            rex_file::copy($this->getPath('assets/consent_manager_frontend.js'), $this->getAssetsPath('consent_manager_frontend.js'));
        }
        if (rex::isBackend() && rex_be_controller::getCurrentPagePart(1) == 'consent_manager')
        {
            rex_view::addCssFile($this->getAssetsUrl('consent_manager_backend.css'));
        }
    }
});

rex_extension::register('OUTPUT_FILTER', function (rex_extension_point $ep) {
    if (rex::isBackend() && rex_clang::count() == 1)
    {
        $s = '</head>';
        $r = '<style>[id*="rex-page-consent_manager"] .rex-page-nav .navbar{display:none}</style></head>';
        $ep->setSubject(str_replace($s, $r, $ep->getSubject()));
    }
});
rex_extension::register('REX_FORM_CONTROL_FIELDS', 'consent_manager_rex_form::removeDeleteButton');
rex_extension::register('PAGES_PREPARED', 'consent_manager_clang::addLangNav');
rex_extension::register('REX_FORM_SAVED', 'consent_manager_clang::formSaved');
rex_extension::register('REX_FORM_SAVED', 'consent_manager_cache::write');
rex_extension::register('CLANG_ADDED', 'consent_manager_clang::clangAdded');
rex_extension::register('CLANG_DELETED', 'consent_manager_clang::clangDeleted');

if (rex_be_controller::getCurrentPagePart(1) == 'consent_manager' && $this->getConfig('justInstalled'))
{
    $this->setConfig('justInstalled', false);
    consent_manager_clang::addonJustInstalled();
}
if ($this->getConfig('forceCache')) {
    $this->setConfig('forceCache', false);
    consent_manager_cache::forceWrite();
}
if (rex::isFrontend()){
    if (!isset($_SESSION)) session_start();
}
rex_extension::register('OUTPUT_FILTER', function (rex_extension_point $ep) {
    if (rex::isFrontend())
    {
        $consent_manager = isset($_COOKIE['consent_manager']) ? json_decode($_COOKIE['consent_manager'], 1) : false;
        $outcssjs = !$this->getConfig('outputcssjs', false);
        $_search = '<!--REX_CONSENT_MANAGER_OUTPUT[]-->';
        $_replace = '';
        if (!$consent_manager || $outcssjs || strstr($ep->getSubject(), 'consent_manager-show-box') || strstr($ep->getSubject(), 'consent_manager-show-box-reload')) {
            $_replace = $_SESSION['consent_manager']['outputcssjs'];
        }
        $ep->setSubject(str_replace($_search, $_replace, $ep->getSubject()));
    }
});

rex_extension::register('FE_OUTPUT', static function (rex_extension_point $ep) {
    if (rex_get('consent_manager_outputjs', 'bool', false) === true) {
        $consent_manager = new consent_manager_frontend(0);
        $consent_manager->setDomain($_SERVER['HTTP_HOST']);
        $consent_manager->outputJavascript();
    }
});
